﻿Public Class frmStopwatch
  Dim StartTime As Date
  Dim StopTime As Date
  Dim StoppedTime As Integer

  Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
    Me.Close()
  End Sub

  Private Sub btnReset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReset.Click
    'return to initial state
    lblRunning.Text = "00:00:00"
    lblTotal.Text = "00:00:00"
    btnStartStop.Text = "Start"
    btnReset.Enabled = False
  End Sub

  Private Sub btnStartStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStartStop.Click
    If btnStartStop.Text = "Start" Then
      'initial to running state
      StartTime = Now
      StoppedTime = 0
      timDisplay.Enabled = True
      btnStartStop.Text = "Stop"
      btnExit.Enabled = False
    ElseIf btnStartStop.Text = "Stop" Then
      'running to stopped state
      StopTime = Now
      timDisplay.Enabled = False
      btnStartStop.Text = "Restart"
      btnReset.Enabled = True
      btnExit.Enabled = True
    ElseIf btnStartStop.Text = "Restart" Then
      'stopped to running state
      timDisplay.Enabled = True
      StoppedTime += DateDiff(DateInterval.Second, StopTime, Now)
      btnStartStop.Text = "Stop"
      btnReset.Enabled = False
      btnExit.Enabled = False
    End If
  End Sub

 

  Private Function HMS(ByVal T As Integer) As String
    Dim H As Integer, M As Integer, S As Integer
    'Break time down into hours, minutes, and seconds
    H = T \ 3600 ' note integer division
    M = (T - H * 3600) \ 60 ' again integer division
    S = T - H * 3600 - M * 60
    Return (Format(H, "00") & ":" & Format(M, "00") & ":" & Format(S, "00"))
  End Function

  Private Sub timDisplay_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles timDisplay.Tick
    Dim CurrentTime As Date
    Dim TotalTime As Integer
    Dim RunningTime As Integer
    'Determine total and running times in seconds
    CurrentTime = Now
    TotalTime = DateDiff(DateInterval.Second, StartTime, CurrentTime)
    RunningTime = TotalTime - StoppedTime
    'Display times
    lblTotal.Text = HMS(TotalTime)
    lblRunning.Text = HMS(RunningTime)
  End Sub
End Class
